import launch
import launch.actions
import launch.substitutions
import launch_ros.actions
import launch.conditions

def generate_launch_description():
    ns = launch.actions.DeclareLaunchArgument(
        'ns',
        default_value='/',
        description='Namespace in which to launch nodes')
    {% if resources %}
    resource_bridge = launch_ros.actions.Node(
        package='{{ pkgname }}',
        executable='resource_bridge',
        name='resource_bridge',
        respawn=True,
        output='both',
        namespace=launch.substitutions.LaunchConfiguration('ns'))
    {% endif %}
    {% if data %}
    data_bridge = launch_ros.actions.Node(
        package='{{ pkgname }}',
        executable='data_bridge',
        name='data_bridge',
        respawn=True,
        output='both',
        namespace=launch.substitutions.LaunchConfiguration('ns'))
    {% endif %}
    {% for sk in skills %}
    {{ sk }}_bridge = launch_ros.actions.Node(
        package='{{ pkgname }}',
        executable='{{ sk }}_bridge',
        name='{{ sk }}_bridge',
        respawn=True,
        output='both',
        namespace=launch.substitutions.LaunchConfiguration('ns'))
    {% endfor %}

    return launch.LaunchDescription([ns,
        {% if data %}data_bridge,{% endif %}{% if resources %}resource_bridge,{% endif %}
        {% for sk in skills %}{{ sk }}_bridge,{% endfor %}
    ])
